=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-09-15 17:48:08 +0000
+++ bzrlib/diff.py	2005-09-16 12:53:47 +0000
@@ -169,7 +169,7 @@
     if revision2 is None:
         new_tree = b.working_tree()
     else:
-        new_tree = b.revision_tree(revision2.in_branch(b).rev_id)
+        new_tree = b.revision_tree(revision2.in_history(b).rev_id)
 
     show_diff_trees(old_tree, new_tree, output, specific_files,
                     external_diff_options)

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-09-16 12:59:36 +0000
+++ bzrlib/selftest/blackbox.py	2005-09-16 13:28:33 +0000
@@ -160,7 +160,6 @@
         self.run_bzr('mv', 'a', 'c', 'subdir')
         self.run_bzr('mv', 'subdir/a', 'subdir/newa')
 
-
     def test_main_version(self):
         """Check output from version command and master option is reasonable"""
         # output is intentionally passed through to stdout so that we
@@ -185,6 +184,15 @@
         test.runbzr('add goodbye')
         test.runbzr('commit -m setup goodbye')
 
+    def test_diff(self):
+        self.example_branch()
+        file('hello', 'wt').write('hello world!')
+        self.runbzr('commit -m fixing hello')
+        output = self.runbzr('diff -r 2..3', backtick=1)
+        self.assert_('\n+hello world!' in output)
+        output = self.runbzr('diff -r last:3..last:1', backtick=1)
+        self.assert_('\n+baz' in output)
+
     def test_revert(self):
         self.example_branch()
         file('hello', 'wt').write('bar')
@@ -257,7 +265,7 @@
         os.chdir('../b')
         self.runbzr('pull ../a')
         assert a.revision_history()[-1] == b.revision_history()[-1]
-
+        
     def test_add_reports(self):
         """add command prints the names of added files."""
         b = Branch.initialize('.')

